--
-- eDAQ expmod driver ioctl access functions
--

local bit = require 'bit'
local ffi = require 'ffi'

local edaq_expmod_ioctl = {}

ffi.cdef[[
int ioctl(int fd, int cmd, ...);
]]

function edaq_expmod_ioctl.reset(fd)
    ffi.C.ioctl(fd, 1, 0);
end

function edaq_expmod_ioctl.enable(fd)
    ffi.C.ioctl(fd, 3, 0);
end

function edaq_expmod_ioctl.disable(fd)
    ffi.C.ioctl(fd, 2, 0);
end

function edaq_expmod_ioctl.check_error(fd)
    local result = ffi.new('unsigned int[1]')
    ffi.C.ioctl(fd, 255, result);
    return tonumber(result[0])
end

function edaq_expmod_ioctl.filter(fd, min_port, max_port)
    local ioctl_data = bit.bor(bit.band(min_port, 0xffff),
                               bit.lshift(bit.band(max_port, 0xffff), 16))
    ffi.C.ioctl(fd, 9, ffi.new('unsigned int', ioctl_data));
end

return edaq_expmod_ioctl

