local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('bits_types')

ffi.cdef[[
typedef __ssize_t ssize_t;
]]

lj_include('stddef')

ffi.cdef[[
typedef __gid_t gid_t;
typedef __uid_t uid_t;
typedef __off_t off_t;
typedef __off64_t off64_t;
typedef __useconds_t useconds_t;
typedef __pid_t pid_t;
typedef __intptr_t intptr_t;
typedef __socklen_t socklen_t;
int access(const char *__name, int __type);
int euidaccess(const char *__name, int __type);
int eaccess(const char *__name, int __type);
int faccessat(int __fd, const char *__file, int __type, int __flag);
__off_t lseek(int __fd, __off_t __offset, int __whence);
__off64_t lseek64(int __fd, __off64_t __offset, int __whence);
int close(int __fd);
ssize_t read(int __fd, void *__buf, size_t __nbytes);
ssize_t write(int __fd, const void *__buf, size_t __n);
ssize_t pread(int __fd, void *__buf, size_t __nbytes, __off_t __offset);
ssize_t pwrite(int __fd, const void *__buf, size_t __n, __off_t __offset);
ssize_t pread64(int __fd, void *__buf, size_t __nbytes,
    __off64_t __offset);
ssize_t pwrite64(int __fd, const void *__buf, size_t __n,
    __off64_t __offset);
int pipe(int __pipedes[2]);
int pipe2(int __pipedes[2], int __flags);
unsigned int alarm(unsigned int __seconds);
unsigned int sleep(unsigned int __seconds);
__useconds_t ualarm(__useconds_t __value, __useconds_t __interval);
int usleep(__useconds_t __useconds);
int pause(void);
int chown(const char *__file, __uid_t __owner, __gid_t __group);
int fchown(int __fd, __uid_t __owner, __gid_t __group);
int lchown(const char *__file, __uid_t __owner, __gid_t __group);
int fchownat(int __fd, const char *__file, __uid_t __owner,
    __gid_t __group, int __flag);
int chdir(const char *__path);
int fchdir(int __fd);
char *getcwd(char *__buf, size_t __size);
char *get_current_dir_name(void);
char *getwd(char *__buf);
int dup(int __fd);
int dup2(int __fd, int __fd2);
int dup3(int __fd, int __fd2, int __flags);
char **__environ;
char **environ;
int execve(const char *__path, char *const __argv[], char *const __envp[]);
int fexecve(int __fd, char *const __argv[], char *const __envp[]);
int execv(const char *__path, char *const __argv[]);
int execle(const char *__path, const char *__arg, ...);
int execl(const char *__path, const char *__arg, ...);
int execvp(const char *__file, char *const __argv[]);
int execlp(const char *__file, const char *__arg, ...);
int nice(int __inc);
void _exit(int __status);
]]

lj_include('bits_confname')

ffi.cdef[[
long int pathconf(const char *__path, int __name);
long int fpathconf(int __fd, int __name);
long int sysconf(int __name);
size_t confstr(int __name, char *__buf, size_t __len);
__pid_t getpid(void);
__pid_t getppid(void);
__pid_t getpgrp(void);
__pid_t __getpgid(__pid_t __pid);
__pid_t getpgid(__pid_t __pid);
int setpgid(__pid_t __pid, __pid_t __pgid);
int setpgrp(void);
__pid_t setsid(void);
__pid_t getsid(__pid_t __pid);
__uid_t getuid(void);
__uid_t geteuid(void);
__gid_t getgid(void);
__gid_t getegid(void);
int getgroups(int __size, __gid_t __list[]);
int group_member(__gid_t __gid);
int setuid(__uid_t __uid);
int setreuid(__uid_t __ruid, __uid_t __euid);
int seteuid(__uid_t __uid);
int setgid(__gid_t __gid);
int setregid(__gid_t __rgid, __gid_t __egid);
int setegid(__gid_t __gid);
int getresuid(__uid_t * __ruid, __uid_t * __euid, __uid_t * __suid);
int getresgid(__gid_t * __rgid, __gid_t * __egid, __gid_t * __sgid);
int setresuid(__uid_t __ruid, __uid_t __euid, __uid_t __suid);
int setresgid(__gid_t __rgid, __gid_t __egid, __gid_t __sgid);
__pid_t fork(void);
__pid_t vfork(void);
char *ttyname(int __fd);
int ttyname_r(int __fd, char *__buf, size_t __buflen);
int isatty(int __fd);
int ttyslot(void);
int link(const char *__from, const char *__to);
int linkat(int __fromfd, const char *__from, int __tofd,
    const char *__to, int __flags);
int symlink(const char *__from, const char *__to);
ssize_t readlink(const char *__path, char *__buf, size_t __len);
int symlinkat(const char *__from, int __tofd, const char *__to);
ssize_t readlinkat(int __fd, const char *__path,
    char *__buf, size_t __len);
int unlink(const char *__name);
int unlinkat(int __fd, const char *__name, int __flag);
int rmdir(const char *__path);
__pid_t tcgetpgrp(int __fd);
int tcsetpgrp(int __fd, __pid_t __pgrp_id);
char *getlogin(void);
int getlogin_r(char *__name, size_t __name_len);
int setlogin(const char *__name);
]]

lj_include('getopt')

ffi.cdef[[
int gethostname(char *__name, size_t __len);
int sethostname(const char *__name, size_t __len);
int sethostid(long int __id);
int getdomainname(char *__name, size_t __len);
int setdomainname(const char *__name, size_t __len);
int vhangup(void);
int revoke(const char *__file);
int profil(unsigned short int *__sample_buffer, size_t __size,
    size_t __offset, unsigned int __scale);
int acct(const char *__name);
char *getusershell(void);
void endusershell(void);
void setusershell(void);
int daemon(int __nochdir, int __noclose);
int chroot(const char *__path);
char *getpass(const char *__prompt);
int fsync(int __fd);
long int gethostid(void);
void sync(void);
int getpagesize(void);
int getdtablesize(void);
int truncate(const char *__file, __off_t __length);
int truncate64(const char *__file, __off64_t __length);
int ftruncate(int __fd, __off_t __length);
int ftruncate64(int __fd, __off64_t __length);
int brk(void *__addr);
void *sbrk(intptr_t __delta);
long int syscall(long int __sysno, ...);
int lockf(int __fd, int __cmd, __off_t __len);
int lockf64(int __fd, int __cmd, __off64_t __len);
int fdatasync(int __fildes);
char *crypt(const char *__key, const char *__salt);
void encrypt(char *__block, int __edflag);
void swab(const void *__from, void *__to, ssize_t __n);
char *ctermid(char *__s);
]]

local defs = {
    STDIN_FILENO = '0',
    STDOUT_FILENO = '1',
    STDERR_FILENO = '2',
    R_OK = '4',
    W_OK = '2',
    X_OK = '1',
    F_OK = '0',
    SEEK_SET = '0',
    SEEK_CUR = '1',
    SEEK_END = '2',
    L_SET = '0',
    L_INCR = '1',
    L_XTND = '2',
    F_ULOCK = '0',
    F_LOCK = '1',
    F_TLOCK = '2',
    F_TEST = '3',
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

