
--[[
	Little utilities file for logging and other random calls.
]]

help = {}
help.log_file = nil
help.log_name = nil

function help:set_log( file )
	os.execute( "echo '' > "..file )
	self.log_file = assert( io.open( file , "w" ))
	self.log_name = file
end

function help:release_log( file )
	self.log_file:close()
end

function help:incomplete()
	self:warn( "Function incomplete." )
end

function help:warn( err )
	local msg = "!!Exception Occurred!!\n"..err
	print( msg )
	self:log( msg )
	os.exit()
end

function help:log( msg )
	self.log_file:write( msg..'\n' )
end

function help:plog( msg )
	print( msg )
	self:log( msg )
end

function help:clean() --Reenable!
	--os.execute( "rm /tmp/*.sdb 2>> " .. self.log_name )
	--os.execute( "rm /tmp/*.csv 2>> " .. self.log_name )
	--os.execute( "rm *.sql 2>> " .. self.log_name )
end

function help:clean_text( text )
	return string.match( text , "(.+)%..+" )
end



function help:read( file_name )
	local possible_file = io.open( file_name , "r" )
	if possible_file then
		return possible_file:read("*a")
	else
		return nil
	end
end

function help:steal( file_name )
	local possible_file = io.popen( "ls /tmp/" .. file_name ):read("*all") --change to .sdbx later
	possible_file = string.match( possible_file , "%w[%w%-%s_%(%)]+%.%w+" )

	if possible_file and string.len( possible_file ) > 5 and not string.match( possible_file , "%..-%." ) then
		return possible_file , self:read( possible_file )
	else
		return nil
	end
end


return help
