

schema_info = {
	
	About = { 
		size = 3 --not literal size, but upper boundary on size
		,sample_column = "Version"
	}

	,Groups = {
		size = 8
		,sample_column = "Deletable"
	}

	,SenPara = {
		size = 80
		,sample_column = "Excitation"
	}

}


return schema_info

--[[

	for db_table , columns in pairs( schema_info.struct ) do
		--There is redundancy below to improve readability (I hope) and maintain correct ordering for insertion.

		local db_table_empty = columns[1] == nil
		if not db_table_empty then


			--Assemble CREATE TABLE statement
			create_intro = "CREATE TABLE IF NOT EXISTS " .. db_table .. " (\n\t"
			create_chain = '"Source_File" TEXT \n\t'
			local data = find_example_data_set( db_table , lines )
			for i , column in ipairs( columns ) do
				create_chain = create_chain .. "," .. column .. '\t' .. check_data_type( data[ i ] ) .. '\n\t'
			end
			flatfile:write( create_intro .. create_chain .. ');\n\n')


			--In case user is uploading same db source again, remove old entries
			flatfile:write( "DELETE FROM " .. db_table .. " WHERE Source_File = " .. '"' .. source_name .. '";\n\n' )


			--Assemble INSERT VALUE statements.
			flatfile:write( "BEGIN TRANSACTION;\n" )
			insert_chain = ""
			for line , curr_table in pairs( lines ) do
				if curr_table == db_table then
					insert_intro = "INSERT INTO " .. db_table .. ' VALUES (\n'
					insert_chain = insert_chain .. insert_intro .. '"' .. source_name .. '" '

					for i , value in ipairs( line ) do
						insert_chain = insert_chain .. ', ' .. value
					end

					insert_chain = insert_chain .. ');\n'
				end
			end
			flatfile:write( insert_chain )
			flatfile:write( "END TRANSACTION;\n\n" )
		end
	end
	return lines
end]]