local m = {}

m.multi_fanout = true

-- setup-compiler module support

local cm_mt = {__index = m}

function m:cm_new(args)
    return setmetatable(args or {}, cm_mt)
end

function m:cm_run(name)
    local o = {}
    local tv = {}
    local edges = self.node.output_edges
    o[#o + 1] = self.compiler:template({output = false}, [==[
    |    local count = (=processable_count=)
    |    for i = 0, count - 1 do
    |        local v = (=input_edges.1.buf=):deq()
    ]==], {cm_name = name}, tv, self.node)
    for i = 1, #edges do
        o[#o + 1] = self.compiler:template({output = false}, [==[
        |        (=out_edge.buf=):enq()[0] = v[0]
        ]==], {cm_name = name, out_edge = edges[i]}, self.node)
    end
    o[#o + 1] = self.compiler:template({output = false}, [==[
    |    end
    |    more = count > 0 or more
    ]==], {cm_name = name}, tv, self.node)
    return table.concat(o)
end

return m
