local ffi = require("ffi")

local uuid_lib = ffi.load("libuuid.so.1") -- KLUDGE no auto-search '.so.1'

ffi.cdef[[
typedef unsigned char uuid_t[16];

void uuid_generate(uuid_t out);
void uuid_unparse_lower(uuid_t uu, char *out);
]]

local m = {}

function m.generate()
    local uu = ffi.new("uuid_t")
    local uuid = ffi.new("uint8_t[?]", 40)

    uuid_lib.uuid_generate(uu)
    uuid_lib.uuid_unparse_lower(uu, uuid)
    return ffi.string(uuid)
end

return m
